<?php

namespace SuperRhino\Utils\Common;

use Psr\Http\Server\MiddlewareInterface;

abstract class BaseMiddleware implements MiddlewareInterface {
    protected array $ignorePath = [
        '/',
    ];
    protected array $required = [
        '/',
    ];

    public function ignore($patch): bool {
        foreach ($this->ignorePath as $value) {
            if (fnmatch($value, $patch)) {
                return true;
            }
        }
        return false;
    }

    public function required($patch): bool {
        foreach ($this->required as $value) {
            if (fnmatch($value, $patch)) {
                return true;
            }
        }
        return false;
    }
}